/*
    QAD - Qt ADvanced

	Ivan Pelipenko peri4ko@yandex.ru

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef mapitemellipse_h
#define mapitemellipse_h

#include "mapitemnongeogeometrybase.h"


/// ellipse in meters, based on map scale at "position", or pixels
/// north = 0 deg, positive is clockwise
class QAD_MAP_EXPORT MapItemEllipse: public MapItemNonGeoGeometryBase {
public:
	MapItemEllipse(const QRectF & r = QRectF());
	MapItemEllipse(const QPointF & p, double rx, double ry);


	QRectF rect() const { return rct; }
	double startAngle() const { return sa; }
	double endAngle() const { return ea; }
	void setStartAngle(double a);
	void setEndAngle(double a);
	void setEllipse(const QRectF & r);
	void setEllipse(const QPointF & p, double rx, double ry);

protected:
	void draw(QPainter * p) override;
	void rebuild();

private:
	QRectF rct;
	QPolygonF pol;
	double sa = 0., ea = 0.;
};


#endif
